moduleMohSettingsSide1 = {};

function moduleMohSettingsSide1:generate(installModGuiTablePos, masterPage, slavePage, pageSide)
	----is line/button a pullDownMenue ---> check is pullDownOpen or not --> g_currentMission.guiMenue.master.isPullDownOpen()		
	local isGenerate, errorTxt = true, "";
	function printError()
		if not isGenerate and string.len(tostring(errorTxt)) > 0 then print(tostring(errorTxt));end;
	end;	
	local lineButtonTable = {};	
	local lineCmdTable = {};
	--line 1		
	for modul=1, #moModule.guiMenue do		
		lineCmdTable[modul] = {};
		lineCmdTable[modul].cmdTable = nil;
		lineCmdTable[modul].cmdValue = nil;
		lineCmdTable[modul].cmdType = "stringOnly";
		lineCmdTable[modul].buttonTxt = tostring(moModule.guiMenue[modul]);		
		lineCmdTable[modul].isSelect = tostring(moModule.guiMenue[modul]) == "moFillTypes";		
	end;
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "moduleMohSelectSettings_";
		isHidden = false; 
		buttonType = 2; 
		buttonWidth = 0; 		
		txtOverButton = "Select Modul";		
		helpIcon = 0; 
		helpTxt = {""};
		infoTxt = "Select Modul for Settings";
		cmdTable = lineCmdTable;
		cmdValue = nil;
		cmdType = "pullDown_1";
		buttonTxt = "";
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=1, maxButtons=1, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();
	--line 1
	--line 2
	lineButtonTable = {};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "moduleMohUpdateTimer_";
		isHidden = false; 
		buttonType = 3; 
		buttonWidth = 0; 		
		txtOverButton = "Update Timer";		
		helpIcon = 0; 
		helpTxt = {""};
		infoTxt = "Set Update Timer (think about your performance)\nonly running when the slot is open\nMax Timer ".. tostring(moModule.values.maxTimer);
		cmdTable = nil;
		cmdValue = "updateTimer";
		cmdType = "int";
		buttonTxt = "";
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "moduleMohUpdateMsec_";
		isHidden = false; 
		buttonType = 5; 
		buttonWidth = 0; 		
		txtOverButton = "Timer at Msec";		
		helpIcon = 0; 
		helpTxt = {""};
		infoTxt = "Set Update Timer at Millisec (think about your performance)\nonly running when the slot is open";
		cmdTable = nil;
		cmdValue = "msec";
		cmdType = "boolean";
		buttonTxt = "";
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=2, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();	
	--line 3
	lineButtonTable = {};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "moduleMohLanguageXml_";
		isHidden = false; 
		buttonType = 5; 
		buttonWidth = 0; 		
		txtOverButton = "Language XML Global";		
		helpIcon = 0; 
		helpTxt = {""};
		infoTxt = "Load Text(all) too over language.xml";
		cmdTable = moModule.values;
		cmdValue = "languageXml";
		cmdType = "boolean";
		buttonTxt = "";
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "moduleMohTxtBold_";
		isHidden = false; 
		buttonType = 5; 
		buttonWidth = 0; 		
		txtOverButton = "Text Bold Global";		
		helpIcon = 0; 
		helpTxt = {""};
		infoTxt = "Set Slot(all) Text Bold (Is Text toLong for Slot, set TextWitdhFix at Slot Settings)";
		cmdTable = moModule.values;
		cmdValue = "txtBold";
		cmdType = "boolean";
		buttonTxt = "";
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=3, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();
	--line 3
end;

function moduleMohSettingsSide1:setReturnClick(self, returnClick, whichPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, isVirtualReturnClick) --byName (virtual.... for Activate over Mod(not over Gui Menue click)for set Icons or at GuiMenue or or etc)
	local whichSubPDA = whichPDA or "masterPDA_";
	local upOrLeft = string.find(returnClick, "_Up") or string.find(returnClick, "_Left");
	local downOrRight = string.find(returnClick, "_Down") or string.find(returnClick, "_Right");
	
	local defaultPageSide = 1; --ändern wenn die seite verschoben wird
	
	if string.find(returnClick, "moduleMohSelectSettings_") then		
		moduleMohSettingsSide1:resetModuleGuiMenue(true);
		return;
		
	elseif string.find(returnClick, "moduleMohUpdateTimer_") and not pullDownOpen then		
		local whichSubModul, modulName = moduleMohSettingsSide1:getSelectModul();
		if modulName ~= nil and modulName.updateTimer ~= nil then
			local inOutLevel = 1;
			if upOrLeft then
				if modulName.updateTimer+inOutLevel > moModule.values.maxTimer then return;end;
				modulName.updateTimer = modulName.updateTimer+inOutLevel;
			elseif downOrRight then
				if modulName.updateTimer-inOutLevel < 0 then return;end;
				modulName.updateTimer = modulName.updateTimer-inOutLevel;
			end;
			g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].tempSave = true;
		end;
		return;
	elseif string.find(returnClick, "moduleMohUpdateMsec_") and not pullDownOpen then		
		local whichSubModul, modulName = moduleMohSettingsSide1:getSelectModul();
		if modulName ~= nil and modulName.msec ~= nil then
			if modulName.msec then modulName.msec = false;else modulName.msec = true;end;			
			g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].tempSave = true;
		end;		
		return;
	elseif string.find(returnClick, "moduleMohLanguageXml_") and not pullDownOpen then		
		if moModule.values.languageXml then moModule.values.languageXml = false;else moModule.values.languageXml = true;end;		
		g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].tempSave = true;
		return;
	elseif string.find(returnClick, "moduleMohTxtBold_") and not pullDownOpen then		
		if moModule.values.txtBold then moModule.values.txtBold = false;else moModule.values.txtBold = true;end;
		g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].tempSave = true;
		return;		
	end;
	return;
end;

function moduleMohSettingsSide1:resetModuleGuiMenue()
	local whichSubModul, modulName = moduleMohSettingsSide1:getSelectModul();	
	local defaultPageSide = 1; --ändern wenn die seite verschoben wird
	local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="moduleMohUpdateTimer_"} );
	if getThisButtonPage == nil then return;end;
	local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
	local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
	buttonTable.cmdTable = modulName;
	
	getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="moduleMohUpdateMsec_"} );
	if getThisButtonPage == nil then return;end;
	guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
	buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
	buttonTable.cmdTable = modulName;
	if modulName == nil then
		
	end;
end;

function moduleMohSettingsSide1:getSelectModul()
	local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="moduleMohSelectSettings_"} );
	local modulName = nil;
	if getThisButtonPage == nil then return nil;end;	
	local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
	local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
	local selectLine = moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);
	local whichSubModul = buttonTable.cmdTable[selectLine].buttonTxt;	
	if whichSubModul ~= nil then
		if whichSubModul == "moFillTypes" then modulName = moFillTypes.values;
		elseif whichSubModul == "moAmount" then modulName = moAmount.values;
		elseif whichSubModul == "moAnimals" then modulName = moAnimals.values;
		elseif whichSubModul == "moBGAs" then modulName = moBGAs.values;
		elseif whichSubModul == "moBunkerSilos" then modulName = moBunkerSilos.values;
		elseif whichSubModul == "moBuyingStations" then modulName = moBuyingStations.values;
		elseif whichSubModul == "moGC_Factorys" then modulName = moGC_Factorys.values;
		elseif whichSubModul == "moFeedMixers" then modulName = moFeedMixers.values;
		elseif whichSubModul == "moGreenhouses" then modulName = moGreenhouses.values;
		elseif whichSubModul == "moGreatDemand" then modulName = moGreatDemand.values;
		elseif whichSubModul == "moItems" then modulName = moItems.values;
		elseif whichSubModul == "moMissions" then modulName = moMissions.values;
		elseif whichSubModul == "moSellingStations" then modulName = moSellingStations.values;
		elseif whichSubModul == "moStorages" then modulName = moStorages.values;
		elseif whichSubModul == "Text Color" then modulName = nil;
		elseif whichSubModul == "Prozent Color" then modulName = nil;
		end;
	end;
	return whichSubModul, modulName;
end;
