moDraw.type = {};

function moDraw.type:setOpenDraw_Type1(...)
	local args = ...;
	local newPosX = 0;
	local newPosY = args.posY-args.slotTable.txtHeight;
	local txt = "";
	local optiSize = 0;
	local txtLength = 0;
	local txtWidth = 0;	
	local tempViewLines = 0;		
	local viewLines = math.abs(args.slotTable.renderViewLines.bounds[2] - args.slotTable.renderViewLines.bounds[1])+1;
	local bounds1 = args.slotTable.renderViewLines.bounds[1];
	local bounds2 = args.slotTable.renderViewLines.bounds[2];
	local longestTxt = 0;
	local width = args.width;	
	local tempOutput = 0;
	local lastTempOutput = 0;
	function setNewSlideRegulator(bounds3)		
		args.slotTable.renderViewText.bounds[3] = longestTxt;
		moDraw.mohSLOT:getSlideRegulatorOverlay(false, 0.0008, args.whichSubSLOT);						
	end;	
	function setLine(lineTable)		
		if tempOutput > lastTempOutput then 
			lastTempOutput = lastTempOutput+1;
			moSetGetOverlays:setOverlay(self, args.overlay["groundLines"], args.posX, newPosY-(0.002)+args.slotTable.txtHeight);
			moDraw.mohSLOT:setLineBorder(self, args.overlay["line"], args.overlay["groundLines"], 1, 0.0015, false, true, false, false);
		end;		
		for a=1, #lineTable do		
			if tempViewLines >= viewLines then break;end;
			if lineTable[a] ~= nil and lineTable[a].view ~= nil and lineTable[a].view then
				local tempLineTable = lineTable[a];
				local size = args.slotTable.size;				
				local lineSettingButtons = tempLineTable.lineClickSettingButtons;
				local buttonWidthLeft = 0;
				local buttonWidthRight = 0;
				local widthTable = moDraw.type:getSlotLineWidth(width, tempLineTable, lineSettingButtons, args.horizontal);
				local tempWidth = widthTable[1]; --width;				
				local txtTable1 = tempLineTable.txt[1];				
				local txt1 = "Not Found";
				if txtTable1 ~= nil then txt1 = tostring(txtTable1.txt);end;
				if longestTxt < string.len(txt1) then longestTxt = string.len(txt1);end;				
				if txtTable1.difSize ~= nil and txtTable1.difSize < args.size then size = size-txtTable1.difSize;end;
				--if txtTable1.width ~= nil and txtTable1.width > 1 then tempWidth = args.width/txtTable1.width;end;
				local txtLength = getTextLineLength(size, txt1, (tempWidth-(args.slotTable.letterWidthBold)))+args.slotTable.txtWidthFix; --difference				
				local subTxt = string.sub(txt1, args.slotTable.renderViewText.bounds[1], txtLength+args.slotTable.renderViewText.bounds[1]);				 
				local firstLetter = string.sub(txt1, args.slotTable.renderViewText.bounds[1], args.slotTable.renderViewText.bounds[1]); --utf8ToUnicode
				if string.len(subTxt) > 0 and subTxt ~= nil then
					local lengthDif = 1;
					if string.len(txt1) < txtLength+args.slotTable.renderViewText.bounds[1] then lengthDif = 0;end;
					if not getCanRenderUnicode(utf8ToUnicode(firstLetter)) and args.slotTable.renderViewText.bounds[1] > 1 then subTxt = utf8Substr(txt1, args.slotTable.renderViewText.bounds[1], txtLength+args.slotTable.renderViewText.bounds[1]-lengthDif);end;
				end;				
				--if (string.len(txtTable1.txt) > (txtLength+args.slotTable.renderViewText.bounds[1])) and args.slotTable.renderViewText.bounds[2] < args.slotTable.renderViewText.bounds[3] then subTxt = subTxt.. "..";end;				
				if txtTable1.bold ~= nil then setTextBold(txtTable1.bold);end;
				if txtTable1.color ~= nil then setTextColor(unpack(txtTable1.color));end;				
				--moSetGetOverlays:setBackgroundColor(args.overlay["groundLines"], moColors.intern["black"]);
				if lineSettingButtons ~= nil and type(lineSettingButtons) == "table" then
					if lineSettingButtons[1] ~= nil or lineSettingButtons[3] ~= nil then 
						buttonWidthLeft = args.horizontal;
						local buttonTyp = "buttonUp"
						local buttonColor = nil;
						if lineSettingButtons[3] ~= nil then 
							buttonTyp = "buttonLeft";
							if tempLineTable.lineClickSettingButtonsColor ~= nil and tempLineTable.lineClickSettingButtonsColor[3] ~= nil then buttonColor = tempLineTable.lineClickSettingButtonsColor[3];end;
						elseif lineSettingButtons[1] ~= nil then
							if tempLineTable.lineClickSettingButtonsColor ~= nil and tempLineTable.lineClickSettingButtonsColor[1] ~= nil then buttonColor = tempLineTable.lineClickSettingButtonsColor[1];end;
						end;
						moSetGetOverlays:setOverlay(nil, args.overlay[buttonTyp], args.posX, newPosY-args.slotTable.verticalTxtDistance);
						if buttonColor ~= nil then
							moSetGetOverlays:setBackgroundColor(args.overlay[buttonTyp], buttonColor);
						else
							moSetGetOverlays:setBackgroundColor(args.overlay[buttonTyp], moColors.intern["white"]);
						end;						
						args.overlay[buttonTyp]:render();
						if not args.disableClickArea and tempLineTable.lineClickSettingButtonsCallback ~= nil and type(tempLineTable.lineClickSettingButtonsCallback) == "function" then
							moDraw.mohSLOT:clickAreas(args.overlay[buttonTyp].x, args.overlay[buttonTyp].x+args.overlay[buttonTyp].width, args.overlay[buttonTyp].y, args.overlay[buttonTyp].y+args.overlay[buttonTyp].height, "clickLineSettingButtonsCallback_UpLeft", args.whichSubSLOT, a, 1, tempLineTable.lineClickSettingButtonsCallback, tempLineTable.ownValues);
						end;
					end;	
					if lineSettingButtons[2] ~= nil or lineSettingButtons[4] ~= nil then
						buttonWidthRight = args.horizontal;
						local buttonTyp = "buttonDown"
						local buttonColor = nil;
						if lineSettingButtons[4] ~= nil then 
							buttonTyp = "buttonRight";
							if tempLineTable.lineClickSettingButtonsColor ~= nil and tempLineTable.lineClickSettingButtonsColor[4] ~= nil then buttonColor = tempLineTable.lineClickSettingButtonsColor[4];end;
						elseif lineSettingButtons[2] ~= nil then
							if tempLineTable.lineClickSettingButtonsColor ~= nil and tempLineTable.lineClickSettingButtonsColor[2] ~= nil then buttonColor = tempLineTable.lineClickSettingButtonsColor[2];end;
						end;
						moSetGetOverlays:setOverlay(nil, args.overlay[buttonTyp], args.posX+width-args.horizontal, newPosY-args.slotTable.verticalTxtDistance);
						if buttonColor ~= nil then
							moSetGetOverlays:setBackgroundColor(args.overlay[buttonTyp], buttonColor);
						else
							moSetGetOverlays:setBackgroundColor(args.overlay[buttonTyp], moColors.intern["white"]);
						end;
						args.overlay[buttonTyp]:render();
						if not args.disableClickArea and tempLineTable.lineClickSettingButtonsCallback ~= nil and type(tempLineTable.lineClickSettingButtonsCallback) == "function" then
							moDraw.mohSLOT:clickAreas(args.overlay[buttonTyp].x, args.overlay[buttonTyp].x+args.overlay[buttonTyp].width, args.overlay[buttonTyp].y, args.overlay[buttonTyp].y+args.overlay[buttonTyp].height, "clickLineSettingButtonsCallback_DownRight", args.whichSubSLOT, a, 1, tempLineTable.lineClickSettingButtonsCallback, tempLineTable.ownValues);
						end;
					end;
				end;
				if txtTable1.txtPos ~= nil and (txtTable1.txtPos == 1 or  txtTable1.txtPos == 2) then					
					if txtTable1.txtPos == 1 then
						local txtPos = args.posX+(width/2)-(getTextWidth(size, tostring(subTxt))/2);						
						renderText(txtPos, newPosY, size, tostring(subTxt));						
						if not args.disableClickArea and txtTable1.clickCallback ~= nil and type(txtTable1.clickCallback) == "function" then									
							moDraw.mohSLOT:clickAreas(txtPos, txtPos+getTextWidth(size, tostring(subTxt)), newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, 1, txtTable1.clickCallback, tempLineTable.ownValues);
						end;
					 elseif txtTable1.txtPos == 2 then
						local txtPos = (args.posX+width)-(getTextWidth(size, tostring(subTxt)))-buttonWidthRight-args.slotTable.horizontalTxtDistance;
						renderText(txtPos, newPosY, size, tostring(subTxt));
						if not args.disableClickArea and txtTable1.clickCallback ~= nil and type(txtTable1.clickCallback) == "function" then									
							moDraw.mohSLOT:clickAreas(txtPos, txtPos+getTextWidth(size, tostring(subTxt)), newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, 1, txtTable1.clickCallback, tempLineTable.ownValues);
						end;
					end;					
				else
					renderText(args.posX+args.slotTable.horizontalTxtDistance+buttonWidthLeft, newPosY, size, tostring(subTxt));
					if not args.disableClickArea and txtTable1.clickCallback ~= nil and type(txtTable1.clickCallback) == "function" then									
						moDraw.mohSLOT:clickAreas(args.posX+args.slotTable.horizontalTxtDistance+buttonWidthLeft, args.posX+args.slotTable.horizontalTxtDistance+buttonWidthLeft+getTextWidth(size, tostring(subTxt)), newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, 1, txtTable1.clickCallback, tempLineTable.ownValues);
					end;
				end;
				if tempLineTable.lineBorder ~= nil and type(tempLineTable.lineBorder) == "table" then --ist wohl noch verbugt
					moSetGetOverlays:setOverlay(self, args.overlay["groundLines"], args.posX, newPosY-(0.002));
					moDraw.mohSLOT:setLineBorder(self, args.overlay["line"], args.overlay["groundLines"], unpack(tempLineTable.lineBorder));					
				end;				
				local clickIcon = false;
				if not args.disableClickArea and tempLineTable.lineClickIcon ~= nil and tempLineTable.lineClickIcon and tempLineTable.lineClickIconCallback ~= nil and type(tempLineTable.lineClickIconCallback) == "function" then
					moSetGetOverlays:setOverlay(nil, args.overlay["lineClickIcon"], args.posX-(args.horizontal/2), newPosY-args.slotTable.verticalTxtDistance);
					--moSetGetOverlays:setOverlay(nil, args.overlay["lineClickIcon"], args.posX, newPosY-args.slotTable.verticalTxtDistance);
					args.overlay["lineClickIcon"]:render();
					moDraw.mohSLOT:clickAreas(args.overlay["lineClickIcon"].x, args.overlay["lineClickIcon"].x+args.overlay["lineClickIcon"].width, args.overlay["lineClickIcon"].y, args.overlay["lineClickIcon"].y+args.overlay["lineClickIcon"].height, "clickIconCallbackLineSlot", args.whichSubSLOT, a, 1, tempLineTable.lineClickIconCallback, tempLineTable.ownValues);
					clickIcon = true;
				end;
				if not args.disableClickArea and args.slotTable.isLineHelp and tempLineTable.lineClickHelp ~= nil and tempLineTable.lineClickHelp and tempLineTable.lineClickHelpCallback ~= nil and type(tempLineTable.lineClickHelpCallback) == "function" then					
					if not clickIcon then
						moSetGetOverlays:setOverlay(nil, args.overlay["lineHelpIcon"], args.posX-(args.horizontal/1.3), newPosY-args.slotTable.verticalTxtDistance);						
					else
						moSetGetOverlays:setOverlay(nil, args.overlay["lineHelpIcon"], args.posX-(args.horizontal*1.2), newPosY-args.slotTable.verticalTxtDistance);
					end;
					moDraw.mohSLOT:clickAreas(args.overlay["lineHelpIcon"].x, args.overlay["lineHelpIcon"].x+args.overlay["lineHelpIcon"].width, args.overlay["lineHelpIcon"].y, args.overlay["lineHelpIcon"].y+args.overlay["lineHelpIcon"].height, "clickHelpIconCallbackLineSlot", args.whichSubSLOT, a, 1, tempLineTable.lineClickHelpCallback, tempLineTable.ownValues);
					args.overlay["lineHelpIcon"]:render();
				end;
				newPosY = newPosY-args.slotTable.txtHeight;
				tempViewLines = tempViewLines+1;			
				setTextBold(false);
				setTextAlignment(0);
				setTextColor(1, 1, 1, 1);								
			end;			
			setTextBold(false);
			setTextAlignment(0);
			setTextColor(1, 1, 1, 1);			
		end;
		if args.slotTable.renderViewText.bounds[3] < longestTxt then setNewSlideRegulator();end;
	end;
	moDraw.type:setOutputLineBounds(args.outputTable, bounds1, bounds2)
	for a=1, #args.outputTable do		
		if args.outputTable[a] ~= nil and args.outputTable[a].line ~= nil and #args.outputTable[a].line > 0 then 
			if tempViewLines >= viewLines then break;end;
			setLine(args.outputTable[a].line)
			tempOutput=tempOutput+1;
		end;		
	end;
	if not args.disableClickArea then moDraw.type:setUpDownButton(args.slotTable, args.overlay, args.whichSubSLOT);end;
end;

function moDraw.type:setOpenDraw_Type2(...)
	local args = ...;
	local newPosX = 0;
	local newPosY = args.posY-args.slotTable.txtHeight;
	local txt = "";
	local optiSize = 0;
	local txtLength = 0;
	local txtWidth = 0;	
	local tempViewLines = 0;		
	local viewLines = math.abs(args.slotTable.renderViewLines.bounds[2] - args.slotTable.renderViewLines.bounds[1])+1;
	local bounds1 = args.slotTable.renderViewLines.bounds[1];
	local bounds2 = args.slotTable.renderViewLines.bounds[2];
	local longestTxt = 0;
	local width = args.width;	
	local tempOutput = 0;
	local lastTempOutput = 0;
	function setNewSlideRegulator(bounds3)		
		args.slotTable.renderViewText.bounds[3] = longestTxt;
		moDraw.mohSLOT:getSlideRegulatorOverlay(false, 0.0008, args.whichSubSLOT);						
	end;	
	function setLine(lineTable)		
		if tempOutput > lastTempOutput then 
			lastTempOutput = lastTempOutput+1;
			moSetGetOverlays:setOverlay(self, args.overlay["groundLines"], args.posX, newPosY-(0.002)+args.slotTable.txtHeight);
			moDraw.mohSLOT:setLineBorder(self, args.overlay["line"], args.overlay["groundLines"], 1, 0.0015, false, true, false, false);
		end;		
		for a=1, #lineTable do		
			if tempViewLines >= viewLines then break;end;
			if lineTable[a] ~= nil and lineTable[a].view ~= nil and lineTable[a].view then
				local tempLineTable = lineTable[a];
				local lineSettingButtons = tempLineTable.lineClickSettingButtons;
				local buttonWidthLeft = 0;
				local buttonWidthRight = 0;
				local size = args.slotTable.size;							
				local widthTable = moDraw.type:getSlotLineWidth(width, tempLineTable, lineSettingButtons, args.horizontal);				
				local tempWidth = widthTable[1]; --width;	
				local txtTable1 = tempLineTable.txt[1];				
				local txtTable2 = tempLineTable.txt[2];				
				local txt1 = "Not Found";
				if txtTable1 ~= nil then txt1 = tostring(txtTable1.txt);end;
				local txt2 = "Not Found";
				if txtTable2 ~= nil then txt2 = tostring(txtTable2.txt);end;				
				if longestTxt < string.len(txt1) then longestTxt = string.len(txt1);end;				
				if txtTable1.difSize ~= nil and txtTable1.difSize < args.size then size = size-txtTable1.difSize;end;
				--if txtTable1.width ~= nil and txtTable1.width > 1 then tempWidth = args.width/txtTable1.width;end;
				local txtLength = getTextLineLength(size, txt1, (tempWidth-(args.slotTable.letterWidthBold)))+args.slotTable.txtWidthFix; --difference				
				local subTxt = string.sub(txt1, args.slotTable.renderViewText.bounds[1], txtLength+args.slotTable.renderViewText.bounds[1]);				 
				local firstLetter = string.sub(txt1, args.slotTable.renderViewText.bounds[1], args.slotTable.renderViewText.bounds[1]); --utf8ToUnicode
				if string.len(subTxt) > 0 and subTxt ~= nil then
					local lengthDif = 1;
					if string.len(txt1) < txtLength+args.slotTable.renderViewText.bounds[1] then lengthDif = 0;end;
					if not getCanRenderUnicode(utf8ToUnicode(firstLetter)) and args.slotTable.renderViewText.bounds[1] > 1 then subTxt = utf8Substr(txt1, args.slotTable.renderViewText.bounds[1], txtLength+args.slotTable.renderViewText.bounds[1]-lengthDif);end;
				end;				
				--if (string.len(txtTable1.txt) > (txtLength+args.slotTable.renderViewText.bounds[1])) and args.slotTable.renderViewText.bounds[2] < args.slotTable.renderViewText.bounds[3] then subTxt = subTxt.. "..";end;				
				if txtTable1.bold ~= nil then setTextBold(txtTable1.bold);end;
				if txtTable1.color ~= nil then setTextColor(unpack(txtTable1.color));end;				
				--moSetGetOverlays:setBackgroundColor(args.overlay["groundLines"], moColors.intern["black"]);
				if lineSettingButtons ~= nil and type(lineSettingButtons) == "table" then
					if lineSettingButtons[1] ~= nil or lineSettingButtons[3] ~= nil then 
						buttonWidthLeft = args.horizontal;
						local buttonTyp = "buttonUp"
						local buttonColor = nil;
						if lineSettingButtons[3] ~= nil then 
							buttonTyp = "buttonLeft";
							if tempLineTable.lineClickSettingButtonsColor ~= nil and tempLineTable.lineClickSettingButtonsColor[3] ~= nil then buttonColor = tempLineTable.lineClickSettingButtonsColor[3];end;
						elseif lineSettingButtons[1] ~= nil then
							if tempLineTable.lineClickSettingButtonsColor ~= nil and tempLineTable.lineClickSettingButtonsColor[1] ~= nil then buttonColor = tempLineTable.lineClickSettingButtonsColor[1];end;
						end;
						moSetGetOverlays:setOverlay(nil, args.overlay[buttonTyp], args.posX, newPosY-args.slotTable.verticalTxtDistance);
						if buttonColor ~= nil then
							moSetGetOverlays:setBackgroundColor(args.overlay[buttonTyp], buttonColor);
						else
							moSetGetOverlays:setBackgroundColor(args.overlay[buttonTyp], moColors.intern["white"]);
						end;						
						args.overlay[buttonTyp]:render();
						if not args.disableClickArea and tempLineTable.lineClickSettingButtonsCallback ~= nil and type(tempLineTable.lineClickSettingButtonsCallback) == "function" then
							moDraw.mohSLOT:clickAreas(args.overlay[buttonTyp].x, args.overlay[buttonTyp].x+args.overlay[buttonTyp].width, args.overlay[buttonTyp].y, args.overlay[buttonTyp].y+args.overlay[buttonTyp].height, "clickLineSettingButtonsCallback_UpLeft", args.whichSubSLOT, a, 1, tempLineTable.lineClickSettingButtonsCallback, tempLineTable.ownValues);
						end;
					end;	
					if lineSettingButtons[2] ~= nil or lineSettingButtons[4] ~= nil then
						buttonWidthRight = args.horizontal;
						local buttonTyp = "buttonDown"
						local buttonColor = nil;
						if lineSettingButtons[4] ~= nil then 
							buttonTyp = "buttonRight";
							if tempLineTable.lineClickSettingButtonsColor ~= nil and tempLineTable.lineClickSettingButtonsColor[4] ~= nil then buttonColor = tempLineTable.lineClickSettingButtonsColor[4];end;
						elseif lineSettingButtons[2] ~= nil then
							if tempLineTable.lineClickSettingButtonsColor ~= nil and tempLineTable.lineClickSettingButtonsColor[2] ~= nil then buttonColor = tempLineTable.lineClickSettingButtonsColor[2];end;
						end;
						moSetGetOverlays:setOverlay(nil, args.overlay[buttonTyp], args.posX+width-args.horizontal, newPosY-args.slotTable.verticalTxtDistance);
						if buttonColor ~= nil then
							moSetGetOverlays:setBackgroundColor(args.overlay[buttonTyp], buttonColor);
						else
							moSetGetOverlays:setBackgroundColor(args.overlay[buttonTyp], moColors.intern["white"]);
						end;
						args.overlay[buttonTyp]:render();
						if not args.disableClickArea and tempLineTable.lineClickSettingButtonsCallback ~= nil and type(tempLineTable.lineClickSettingButtonsCallback) == "function" then
							moDraw.mohSLOT:clickAreas(args.overlay[buttonTyp].x, args.overlay[buttonTyp].x+args.overlay[buttonTyp].width, args.overlay[buttonTyp].y, args.overlay[buttonTyp].y+args.overlay[buttonTyp].height, "clickLineSettingButtonsCallback_DownRight", args.whichSubSLOT, a, 1, tempLineTable.lineClickSettingButtonsCallback, tempLineTable.ownValues);
						end;
					end;
				end;				
				if txtTable1.txtPos ~= nil and (txtTable1.txtPos == 1 or  txtTable1.txtPos == 2) then					
					if txtTable1.txtPos == 1 then
						local txtPos = args.posX+(width/2)-(getTextWidth(size, tostring(subTxt))/2);						
						renderText(txtPos, newPosY, size, tostring(subTxt));						
						if not args.disableClickArea and txtTable1.clickCallback ~= nil and type(txtTable1.clickCallback) == "function" then									
							moDraw.mohSLOT:clickAreas(txtPos, txtPos+getTextWidth(size, tostring(subTxt)), newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, 1, txtTable1.clickCallback, tempLineTable.ownValues);
						end;
					 elseif txtTable1.txtPos == 2 then
						local txtPos = (args.posX+width)-(getTextWidth(size, tostring(subTxt)))-buttonWidthRight-args.slotTable.horizontalTxtDistance;
						renderText(txtPos, newPosY, size, tostring(subTxt));
						if not args.disableClickArea and txtTable1.clickCallback ~= nil and type(txtTable1.clickCallback) == "function" then									
							moDraw.mohSLOT:clickAreas(txtPos, txtPos+getTextWidth(size, tostring(subTxt)), newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, 1, txtTable1.clickCallback, tempLineTable.ownValues);
						end;
					end;					
				else
					renderText(args.posX+args.slotTable.horizontalTxtDistance+buttonWidthLeft, newPosY, size, tostring(subTxt));
					if not args.disableClickArea and txtTable1.clickCallback ~= nil and type(txtTable1.clickCallback) == "function" then									
						moDraw.mohSLOT:clickAreas(args.posX+args.slotTable.horizontalTxtDistance, args.posX+args.slotTable.horizontalTxtDistance+getTextWidth(size, tostring(subTxt)), newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, 1, txtTable1.clickCallback, tempLineTable.ownValues);
					end;
				end;				
				--renderText(args.posX+args.slotTable.horizontalTxtDistance, newPosY, size, tostring(subTxt)); --txt 1
				if txtTable2 ~= nil and txtTable2.bold ~= nil then setTextBold(txtTable2.bold);end;
				if txtTable2 ~= nil and txtTable2.color ~= nil then setTextColor(unpack(txtTable2.color));end;
				--if txtTable2 ~= nil then renderText(args.posX+width-args.slotTable.horizontalTxtDistance-getTextWidth(size, tostring(txt2)), newPosY, size, tostring(txt2));end; --txt 2
				if txtTable2 ~= nil then
					if txtTable2.txtPos ~= nil and (txtTable2.txtPos == 1 or  txtTable2.txtPos == 2) then					
						if txtTable2.txtPos == 1 then
							local txtPos = args.posX+width-((width-tempWidth)/2)+(getTextWidth(size, tostring(txt2))/2);													
							renderText(txtPos, newPosY, size, tostring(txt2));						
							if not args.disableClickArea and txtTable2.clickCallback ~= nil and type(txtTable2.clickCallback) == "function" then									
								moDraw.mohSLOT:clickAreas(txtPos, txtPos+getTextWidth(size, tostring(subTxt)), newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, 2, txtTable2.clickCallback, tempLineTable.ownValues);
							end;
						elseif txtTable2.txtPos == 2 then
							local txtPos = args.posX+width-(width-tempWidth)+args.slotTable.horizontalTxtDistance							
							renderText(txtPos, newPosY, size, tostring(txt2));
							if not args.disableClickArea and txtTable2.clickCallback ~= nil and type(txtTable2.clickCallback) == "function" then									
								moDraw.mohSLOT:clickAreas(txtPos, txtPos+getTextWidth(size, tostring(subTxt)), newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, 2, txtTable2.clickCallback, tempLineTable.ownValues);
							end;
						end;					
					else
						local txtPos = args.posX+width-args.slotTable.horizontalTxtDistance-getTextWidth(size, tostring(txt2));
						renderText(txtPos, newPosY, size, tostring(txt2)); --txt 2
						if not args.disableClickArea and txtTable2.clickCallback ~= nil and type(txtTable2.clickCallback) == "function" then									
							moDraw.mohSLOT:clickAreas(txtPos, txtPos+getTextWidth(size, tostring(txt2)), newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, 2, txtTable2.clickCallback, tempLineTable.ownValues);
						end;
					end;
				end;
				if tempLineTable.lineBorder ~= nil and type(tempLineTable.lineBorder) == "table" then --ist wohl noch verbugt
					moSetGetOverlays:setOverlay(self, args.overlay["groundLines"], args.posX, newPosY-(0.002));					
					moDraw.mohSLOT:setLineBorder(self, args.overlay["line"], args.overlay["groundLines"], unpack(tempLineTable.lineBorder));					
				end;				
				local clickIcon = false;
				if not args.disableClickArea and tempLineTable.lineClickIcon ~= nil and tempLineTable.lineClickIcon and tempLineTable.lineClickIconCallback ~= nil and type(tempLineTable.lineClickIconCallback) == "function" then
					moSetGetOverlays:setOverlay(nil, args.overlay["lineClickIcon"], args.posX-(args.horizontal/2), newPosY-args.slotTable.verticalTxtDistance);
					--moSetGetOverlays:setOverlay(nil, args.overlay["lineClickIcon"], args.posX, newPosY-args.slotTable.verticalTxtDistance);
					args.overlay["lineClickIcon"]:render();
					moDraw.mohSLOT:clickAreas(args.overlay["lineClickIcon"].x, args.overlay["lineClickIcon"].x+args.overlay["lineClickIcon"].width, args.overlay["lineClickIcon"].y, args.overlay["lineClickIcon"].y+args.overlay["lineClickIcon"].height, "clickIconCallbackLineSlot", args.whichSubSLOT, a, 1, tempLineTable.lineClickIconCallback, tempLineTable.ownValues);
					clickIcon = true;
				end;
				if not args.disableClickArea and args.slotTable.isLineHelp and tempLineTable.lineClickHelp ~= nil and tempLineTable.lineClickHelp and tempLineTable.lineClickHelpCallback ~= nil and type(tempLineTable.lineClickHelpCallback) == "function" then					
					if not clickIcon then
						moSetGetOverlays:setOverlay(nil, args.overlay["lineHelpIcon"], args.posX-(args.horizontal/1.3), newPosY-args.slotTable.verticalTxtDistance);						
					else
						moSetGetOverlays:setOverlay(nil, args.overlay["lineHelpIcon"], args.posX-(args.horizontal*1.2), newPosY-args.slotTable.verticalTxtDistance);
					end;
					moDraw.mohSLOT:clickAreas(args.overlay["lineHelpIcon"].x, args.overlay["lineHelpIcon"].x+args.overlay["lineHelpIcon"].width, args.overlay["lineHelpIcon"].y, args.overlay["lineHelpIcon"].y+args.overlay["lineHelpIcon"].height, "clickHelpIconCallbackLineSlot", args.whichSubSLOT, a, 1, tempLineTable.lineClickHelpCallback, tempLineTable.ownValues);
					args.overlay["lineHelpIcon"]:render();
				end;
				newPosY = newPosY-args.slotTable.txtHeight;
				tempViewLines = tempViewLines+1;			
				setTextBold(false);
				setTextAlignment(0);
				setTextColor(1, 1, 1, 1);								
			end;			
			setTextBold(false);
			setTextAlignment(0);
			setTextColor(1, 1, 1, 1);			
		end;
		if args.slotTable.renderViewText.bounds[3] < longestTxt then setNewSlideRegulator();end;
	end;
	moDraw.type:setOutputLineBounds(args.outputTable, bounds1, bounds2)
	for a=1, #args.outputTable do		
		if args.outputTable[a] ~= nil and args.outputTable[a].line ~= nil and #args.outputTable[a].line > 0 then 
			if tempViewLines >= viewLines then break;end;
			setLine(args.outputTable[a].line)
			tempOutput=tempOutput+1;
		end;		
	end;
	if not args.disableClickArea then moDraw.type:setUpDownButton(args.slotTable, args.overlay, args.whichSubSLOT);end;
end;

function moDraw.type:setOpenDraw_Type3_5(...) --slide erstmal Deaktiviert, macht probleme
	local args = ...;
	local newPosX = 0;
	local newPosY = args.posY-args.slotTable.txtHeight;
	local txt = "";
	local optiSize = 0;
	local txtLength = 0;
	local txtWidth = 0;	
	local tempViewLines = 0;		
	local viewLines = math.abs(args.slotTable.renderViewLines.bounds[2] - args.slotTable.renderViewLines.bounds[1])+1;
	local bounds1 = args.slotTable.renderViewLines.bounds[1];
	local bounds2 = args.slotTable.renderViewLines.bounds[2];
	local longestTxt = 0;
	local width = args.width;	
	local tempOutput = 0;
	local lastTempOutput = 0;
	function setNewSlideRegulator()		
		--args.slotTable.renderViewText.bounds[3] = longestTxt;
		--moDraw.mohSLOT:getSlideRegulatorOverlay(false, 0.0008, args.whichSubSLOT);						
	end;	
	function setLine(lineTable)		
		if tempOutput > lastTempOutput then 
			lastTempOutput = lastTempOutput+1;
			moSetGetOverlays:setOverlay(self, args.overlay["groundLines"], args.posX, newPosY-(0.002)+args.slotTable.txtHeight);
			moDraw.mohSLOT:setLineBorder(self, args.overlay["line"], args.overlay["groundLines"], 1, 0.0015, false, true, false, false);
		end;		
		for a=1, #lineTable do		
			if tempViewLines >= viewLines then break;end;
			if lineTable[a] ~= nil and lineTable[a].view ~= nil and lineTable[a].view then
				local tempLineTable = lineTable[a];
				local size = args.slotTable.size;							
				local widthTable = moDraw.type:getSlotLineWidth(width, tempLineTable);
				local tempWidth = 0;				
				for txtPos=1, #tempLineTable.txt do
					tempWidth = tempWidth+widthTable[txtPos];
					local lineTxt = tempLineTable.txt[txtPos];
					local txt = "Not Found";
					if lineTxt ~= nil then txt = lineTxt.txt;end;
					if longestTxt < string.len(txt) then longestTxt = string.len(txt);end;
					if lineTxt.difSize ~= nil and lineTxt.difSize < args.size then size = size-lineTxt.difSize;end;
					local txtLength = getTextLineLength(size, txt, (widthTable[txtPos]-(args.slotTable.letterWidthBold)))+args.slotTable.txtWidthFix; --difference
					local subTxt = string.sub(txt, args.slotTable.renderViewText.bounds[1], txtLength+args.slotTable.renderViewText.bounds[1]);
					local firstLetter = string.sub(txt, args.slotTable.renderViewText.bounds[1], args.slotTable.renderViewText.bounds[1]); --utf8ToUnicode problem				
					if string.len(subTxt) > 0 and subTxt ~= nil then --utf8ToUnicode problem
						local lengthDif = 1;
						if string.len(txt) < txtLength+args.slotTable.renderViewText.bounds[1] then lengthDif = 0;end;
						if not getCanRenderUnicode(utf8ToUnicode(firstLetter)) and args.slotTable.renderViewText.bounds[1] > 1 then subTxt = utf8Substr(txt, args.slotTable.renderViewText.bounds[1], txtLength+args.slotTable.renderViewText.bounds[1]-lengthDif);end;
					end;
					if lineTxt.bold ~= nil then setTextBold(lineTxt.bold);end;
					if lineTxt.color ~= nil then setTextColor(unpack(lineTxt.color));end;
					if txtPos == 1 then --first
						renderText(args.posX+args.slotTable.horizontalTxtDistance, newPosY, size, tostring(subTxt)); --txt
					elseif txtPos == #tempLineTable.txt then --end
						renderText(args.posX+tempWidth-args.slotTable.horizontalTxtDistance-getTextWidth(size, tostring(subTxt)), newPosY, size, tostring(subTxt));
					else --middle
						renderText(args.posX+tempWidth-args.slotTable.horizontalTxtDistance-(getTextWidth(size, tostring(subTxt))/2)-(widthTable[txtPos]/2), newPosY, size, tostring(subTxt));
					end;
					if not args.disableClickArea then
						if txtPos == 1 and lineTxt.clickCallback ~= nil and type(lineTxt.clickCallback) == "function" then
							moDraw.mohSLOT:clickAreas(args.posX+args.slotTable.horizontalTxtDistance, args.posX+args.slotTable.horizontalTxtDistance+getTextWidth(size, tostring(subTxt)), newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, txtPos, lineTxt.clickCallback, tempLineTable.ownValues);
						elseif txtPos == #tempLineTable.txt and lineTxt.clickCallback ~= nil and type(lineTxt.clickCallback) == "function" then
							moDraw.mohSLOT:clickAreas(args.posX+args.slotTable.horizontalTxtDistance+tempWidth-getTextWidth(size, tostring(subTxt)), args.posX+tempWidth+args.slotTable.horizontalTxtDistance, newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, txtPos, lineTxt.clickCallback, tempLineTable.ownValues);
						elseif lineTxt.clickCallback ~= nil and type(lineTxt.clickCallback) == "function" then
							moDraw.mohSLOT:clickAreas(args.posX+args.slotTable.horizontalTxtDistance+tempWidth-(getTextWidth(size, tostring(subTxt))/2)-(widthTable[txtPos]/2), args.posX+tempWidth+args.slotTable.horizontalTxtDistance, newPosY-args.slotTable.verticalTxtDistance, newPosY-args.slotTable.verticalTxtDistance+args.slotTable.txtHeight, "clickCallbackLineSlot", args.whichSubSLOT, a, txtPos, lineTxt.clickCallback, tempLineTable.ownValues);
						end;					
					end;
				end;
				--moSetGetOverlays:setBackgroundColor(args.overlay["groundLines"], moColors.intern["black"]);
				if tempLineTable.lineBorder ~= nil and type(tempLineTable.lineBorder) == "table" then --ist wohl noch verbugt
					moSetGetOverlays:setOverlay(self, args.overlay["groundLines"], args.posX, newPosY-(0.002));					
					moDraw.mohSLOT:setLineBorder(self, args.overlay["line"], args.overlay["groundLines"], unpack(tempLineTable.lineBorder));					
				end;
				local clickIcon = false;
				if not args.disableClickArea and tempLineTable.lineClickIcon ~= nil and tempLineTable.lineClickIcon and tempLineTable.lineClickIconCallback ~= nil and type(tempLineTable.lineClickIconCallback) == "function" then
					moSetGetOverlays:setOverlay(nil, args.overlay["lineClickIcon"], args.posX-(args.horizontal/2), newPosY-args.slotTable.verticalTxtDistance);
					args.overlay["lineClickIcon"]:render();
					moDraw.mohSLOT:clickAreas(args.overlay["lineClickIcon"].x, args.overlay["lineClickIcon"].x+args.overlay["lineClickIcon"].width, args.overlay["lineClickIcon"].y, args.overlay["lineClickIcon"].y+args.overlay["lineClickIcon"].height, "clickIconCallbackLineSlot", args.whichSubSLOT, a, 1, tempLineTable.lineClickIconCallback, tempLineTable.ownValues);
					clickIcon = true;
				end;
				if not args.disableClickArea and args.slotTable.isLineHelp and tempLineTable.lineClickHelp ~= nil and tempLineTable.lineClickHelp and tempLineTable.lineClickHelpCallback ~= nil and type(tempLineTable.lineClickHelpCallback) == "function" then					
					if not clickIcon then
						moSetGetOverlays:setOverlay(nil, args.overlay["lineHelpIcon"], args.posX-(args.horizontal/1.3), newPosY-args.slotTable.verticalTxtDistance);						
					else
						moSetGetOverlays:setOverlay(nil, args.overlay["lineHelpIcon"], args.posX-(args.horizontal*1.2), newPosY-args.slotTable.verticalTxtDistance);
					end;
					moDraw.mohSLOT:clickAreas(args.overlay["lineHelpIcon"].x, args.overlay["lineHelpIcon"].x+args.overlay["lineHelpIcon"].width, args.overlay["lineHelpIcon"].y, args.overlay["lineHelpIcon"].y+args.overlay["lineHelpIcon"].height, "clickHelpIconCallbackLineSlot", args.whichSubSLOT, a, 1, tempLineTable.lineClickHelpCallback, tempLineTable.ownValues);
					args.overlay["lineHelpIcon"]:render();
				end;
				newPosY = newPosY-args.slotTable.txtHeight;
				tempViewLines = tempViewLines+1;			
				setTextBold(false);
				setTextAlignment(0);
				setTextColor(1, 1, 1, 1);								
			end;			
			setTextBold(false);
			setTextAlignment(0);
			setTextColor(1, 1, 1, 1);			
		end;
		if args.slotTable.renderViewText.bounds[3] < longestTxt then setNewSlideRegulator();end;
	end;
	moDraw.type:setOutputLineBounds(args.outputTable, bounds1, bounds2)
	for a=1, #args.outputTable do		
		if args.outputTable[a] ~= nil and args.outputTable[a].line ~= nil and #args.outputTable[a].line > 0 then 
			if tempViewLines >= viewLines then break;end;
			setLine(args.outputTable[a].line)
			tempOutput=tempOutput+1;
		end;		
	end;
	if not args.disableClickArea then moDraw.type:setUpDownButton(args.slotTable, args.overlay, args.whichSubSLOT);end;
end;

function moDraw.type:setUpDownButton(slotTable, overlay, whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	if slotTable.renderViewLines.bounds[1] > 1 then
		moSetGetOverlays:setOverlay(nil, overlay["renderViewLinesUp"], overlay["groundMaster"].x+(overlay["groundMaster"].width/2)-(overlay["renderViewLinesUp"].width/2), overlay["groundMaster"].y+(overlay["groundMaster"].height)-(overlay["renderViewLinesUp"].height/2.5));
		overlay["renderViewLinesUp"]:render();
		moDraw.mohSLOT:clickAreas(overlay["renderViewLinesUp"].x, overlay["renderViewLinesUp"].x+overlay["renderViewLinesUp"].width, overlay["renderViewLinesUp"].y, overlay["renderViewLinesUp"].y+overlay["renderViewLinesUp"].height, "renderViewLinesUpSlot", whichSubSLOT, 1, 1);
	end;
	if slotTable.renderViewLines.bounds[2] < slotTable.renderViewLines.bounds[3] then 
		moSetGetOverlays:setOverlay(nil, overlay["renderViewLinesDown"], overlay["groundSlave"].x+(overlay["groundSlave"].width/2)-(overlay["renderViewLinesDown"].width/2), overlay["groundSlave"].y-(overlay["renderViewLinesDown"].height/1.5));
		overlay["renderViewLinesDown"]:render();
		moDraw.mohSLOT:clickAreas(overlay["renderViewLinesDown"].x, overlay["renderViewLinesDown"].x+overlay["renderViewLinesDown"].width, overlay["renderViewLinesDown"].y, overlay["renderViewLinesDown"].y+overlay["renderViewLinesDown"].height, "renderViewLinesDownSlot", whichSubSLOT, 1, 1);
	end;
end;

function moDraw.type:getSlotLineWidth(width, lineTable, lineSettingButtons, horizontal)
	local buttonWidthUpLeft = 0;
	local buttonWidthDownRight = 0;
	if lineSettingButtons ~= nil and type(lineSettingButtons) == "table" then
		if lineSettingButtons[1] ~= nil or lineSettingButtons[3] ~= nil then buttonWidthUpLeft = horizontal;end;
		if lineSettingButtons[2] ~= nil or lineSettingButtons[4] ~= nil then buttonWidthDownRight = horizontal;end;
	end;
	local multi = 100;
	local tempWidth = (width-(buttonWidthDownRight)-(buttonWidthUpLeft))/multi;
	function percent(percent,maxvalue)
		if tonumber(percent) and tonumber(maxvalue) then
			return (maxvalue*percent)/multi;
		end;
		return multi;
	end;
	if lineTable == nil or lineTable.txt == nil or #lineTable.txt < 1 then 
		return {width};
	end;
	local isWidthProzent = 0;
	local newWidth = {};
	for txtPos=1, #lineTable.txt do
		if lineTable.txt[txtPos] ~= nil and lineTable.txt[txtPos].width ~= nil and lineTable.txt[txtPos].width >= 0 and lineTable.txt[txtPos].width <= 100 then
			if (isWidthProzent+lineTable.txt[txtPos].width) <= 100 then
				isWidthProzent = isWidthProzent+lineTable.txt[txtPos].width;
				table.insert(newWidth, txtPos, percent(Utils.getNoNil(lineTable.txt[txtPos].width, 100), multi)*tempWidth);
			elseif isWidthProzent+(multi/#lineTable.txt) <= 100	then			
				isWidthProzent = isWidthProzent+(multi/#lineTable.txt);
				table.insert(newWidth, txtPos, width/#lineTable.txt);			
			end;
		elseif isWidthProzent+(multi/#lineTable.txt) <= 100 then
			isWidthProzent = isWidthProzent+(multi/#lineTable.txt);
			table.insert(newWidth, txtPos, width/#lineTable.txt);		
		end;
	end;	
	if #newWidth == 0 or #newWidth < #lineTable.txt then --error width, set Default			
		for txtPos=1, #lineTable.txt do
			table.insert(newWidth, txtPos, width/#lineTable.txt);
		end;
	end;	
	return newWidth;	
end;

function moDraw.type:setOutputLineBounds(outputTable, bounds1, bounds2)
	local isLinesView = 1;
	for a=1, #outputTable do		
		if outputTable[a] ~= nil and outputTable[a].line ~= nil and #outputTable[a].line > 0 then
			for line=1, #outputTable[a].line do			
				if isLinesView >= bounds1 and isLinesView <= bounds2 then
					outputTable[a].line[line].view = true;
				else
					outputTable[a].line[line].view = false;
				end;			
				isLinesView = isLinesView+1;
			end;
		end;
	end;	
end;